package extensions;

import java.io.IOException;
import java.util.Date;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import dareka.common.Logger;
import dareka.extensions.Extension2;
import dareka.extensions.ExtensionManager;
import dareka.extensions.NLFilterListener;
import dareka.extensions.SystemEventListener;
import dareka.processor.util.GetThumbInfoUtil;

/**
 * Cxg nlFilter g̃Tv
 * <p>
 * IvVw(eventListenerSample.XXXX)ňȉ̋@\:
 * <ul>
 * <li>Ăяo̕\(ShowPeriodicCall)
 * <li>[U[jRLbVȂ(DisableUserCM)
 * <li>nlFilterUNIXTIMEu(ReplaceUNIXTIME)
 * </ul>
 */
public class eventListenerSample implements Extension2,
		SystemEventListener, NLFilterListener {
	
	private static final String KEY = "eventListenerSample.";
	private static final String KEY_SHOWPERIODIC	= KEY + "ShowPeriodicCall";
	private static final String KEY_DISABLEUSERCM	= KEY + "DisableUserCM";
	private static final String KEY_REPLACEUNIXTIME	= KEY + "ReplaceUNIXTIME";
	
	public String getVersionString() {
		return "eventListenerSample rev.3";
	}
	
	public void registerExtensions(ExtensionManager mgr) {
		mgr.registerEventListener(this);
	}
	
	public int onSystemEvent(int id, EventSource source) {
		switch (id) {
		case SYSTEM_EXIT:
			Logger.info("VXeI");
			break;
		case PERIODIC_CALL:
			if (Boolean.getBoolean(KEY_SHOWPERIODIC)) {
				Logger.info("Ăяo: " +
						new Date(System.currentTimeMillis()).toString());
			}
			break;
		case URL_MEMCACHED:
			Logger.info("LbV: " + source.getURL());
			break;
		case CACHE_REQUEST:
			Logger.info("LbVv: " + source.getURL());
			break;
		case CACHE_STARTING:
			if (Boolean.getBoolean(KEY_DISABLEUSERCM)) {
				// 200KBȓnm(=[U[jR)̓LbVȂ
				String videoId = source.getCache().getVideoId();
				if (videoId != null && videoId.startsWith("nm")) {
					int videoSize = getVideoSize(videoId);
					if (0 < videoSize && videoSize <= 200 * 1024) {
						return RESULT_NG;
					}
				}
			}
			Logger.info("LbVJn: " + source.getCache().getId());
			break;
		case CACHE_COMPLETED:
			Logger.info("LbV: " + source.getCache().getId());
			break;
		case CACHE_SUSPENDED:
			Logger.info("LbVf: " + source.getCache().getId());
			break;
		case CACHE_REMOVING:
			Logger.info("LbV폜Jn: " + source.getCache().getId());
			break;
		case CACHE_REMOVED:
			Logger.info("LbV폜: " + source.getCache().getId());
			break;
		case CONFIG_RELOADED:
			Logger.info("RtBOēǍ");
			break;
		}
		return RESULT_OK;
	}
	
	private static final Pattern SIZE_HIGH_PATTERN = Pattern.compile(
			"<size_high>(\\d+)</size_high>");
	
	private int getVideoSize(String id) {
		try {
			String thumbinfo = GetThumbInfoUtil.get(id);
			if (thumbinfo != null) {
				Matcher m = SIZE_HIGH_PATTERN.matcher(thumbinfo);
				if (m.find()) {
					return Integer.parseInt(m.group(1));
				}
			}
		} catch (IOException e) {
			Logger.error(e);
		}
		return -1;
	}
	
	// NLFilterListener ͎bdlȂ̂ŕύX\܂
	
	public void nlFilterBegin(Content content) {
		// <nlVar:eventListenerSample.VERSION> Ńo[W擾
		content.setVariable(KEY + "VERSION", getVersionString());
	}
	
	public String nlVarReplace(String name, Content content) {
		// <nlVar:UNIXTIME> ݎɒu
		if (name.equals("UNIXTIME") && Boolean.getBoolean(KEY_REPLACEUNIXTIME)) {
			return String.format("%d", new Date().getTime() / 1000L);
		}
		return null;
	}
	
	public int idGroup(String s1, String s2) {
		return NLFilterListener.NOT_SUPPORTED;
	}
	
	public void updateLST(String list) {
		Logger.info("LSTp^[XV: " + list);
	}
	
}
